#ifndef parameters_h
#define parameters_h

#define PARAMETER_LINE_LENGTH 100

// flags for asking/not asking various variables
#define PARAM_OMMITVECTOR 1
#define PARAM_WAVEFORMFILEIN 2
#define PARAM_WAVEFORMFILEOUT 4
#define PARAM_WAVEFORMSTORAGE 8
#define PARAM_WAVEFORMLENGTH 16
#define PARAM_NUMPRIMARYINPUTS 32
#define PARAM_TRANSFORMTYPE 512
#define PARAM_TRANSFORMSIZE 64
#define PARAM_DOTHRESHOLD 128
#define PARAM_FAULTFILE 256

class Parameters {
 private:
  bool ask_for_param_file;
  int flag;
  void local_load();

 public:
  // list of values
  string paramfile;

  bool autoload;
  bool ommitvector;
  string waveformfilein;
  string waveformfileout;
  string waveformstorage;
  int waveformlength;
  int numprimaryinputs;
  string transformtype;
  int transformsize;
  bool dothreshold;
  string faultfile;

  // contructor/deconstructor
  Parameters();
  ~Parameters();

  void clear_flag();
  void set_flag(int flag_in);

  // functions
  void load(); // ask for what parameters file to load
  void load(string paramfile_in);  // load from this parameters file

 private:
  void load_parameters();
  bool parse_parameters(string, string);
};

#endif
